
// Проект погодной станции/часов V3.0
// Copyright (C) 2013 Шихарбеев А.В
// Модуль радиосвязи с маршрутизатором по USB

#include <RCSwitch.h> //   http://code.google.com/p/rc-switch/
#include <avr/wdt.h>

#include <RF24Network.h>
#include <RF24.h>
#include <SPI.h>
#define MAX_BUFF 20

// Инициализация премо/передатчика nRF24L01+
RF24 radio(9,10);
RF24Network network(radio);
const uint16_t this_node = 0;
const uint16_t other_node = 1;

unsigned long myData; // данные к отправке

RCSwitch mySwitchReceive = RCSwitch();
RCSwitch mySwitchSend    = RCSwitch();


void(* resetFunc) (void) = 0; // Reset MC function	
unsigned long ms;

void setup() {
  wdt_disable(); // запретили как можно скорее собаку, что-бы не уйти в бесконечный ребут
  Serial.begin(9600);
  Serial.println("Startup");
//  pinMode(5, OUTPUT);
//  pinMode(6, OUTPUT);
//  pinMode(7, OUTPUT);

  mySwitchReceive.enableReceive(0);  // Receiver on inerrupt 0 => that is pin #2  
  mySwitchSend.enableTransmit(4); // инициализация передатчика

  SPI.begin();
  radio.begin();
  network.begin(/*channel*/ 90, /*node address*/ this_node);
  
//  ms        = millis();
}

int len = 0;
char buf[MAX_BUFF];
struct payload_t
{
  unsigned long ms;
  unsigned long counter;
  char buf[MAX_BUFF];
};

    
void loop() {
  
  long int cur_ms;
  payload_t payload;
// Проверяем не прилетело ли чего по радио 433МГц о декодируем значения
  if (mySwitchReceive.available()) { // проверяем датчики
     unsigned long int value = mySwitchReceive.getReceivedValue();
     unsigned int  len       = mySwitchReceive.getReceivedBitlength();
     Serial.println(value);
     mySwitchReceive.resetAvailable();  
  }//end if mySwitch
// Проверяем не прилетело ли чего по радио 2.4ГГц 
  network.update();

  // Is there anything ready for us?
  while ( network.available() )
  {
    // If so, grab it and print it out
//    RF24NetworkHeader header;
//    payload_t payload;
//    network.read(header,&payload,sizeof(payload));
//    Serial.print("aaa" );
//    Serial.println(payload.buf);
   RF24NetworkHeader header;
//    payload_t payload;
    network.read(header,buf,sizeof(buf));
//    Serial.print("Received packet #");
    Serial.println(buf);
  }
  
  
// Проверяем, не прилетело ли чего по ком порту
//если есть данные - читаем
  if(Serial.available()){
     delay(100);
     len=0; 
     //загоняем прочитанное в буфер
     while( Serial.available() ) {
        char c = Serial.read();
        if( len < MAX_BUFF-1 )payload.buf[len++] = c;
     }
     //закрываем массив
     payload.buf[len++]='\0';
  }
// Если буфер не пустой
  if( len > 0 ){
    if( strcmp(payload.buf,"RESET") == 0 )resetFunc();
    RF24NetworkHeader header(/*to node*/ other_node);
    bool ok = network.write(header,&payload.buf,sizeof(payload));
    
    unsigned long data = atol(payload.buf);
    if( data!= 0 ){ 
       mySwitchReceive.disableReceive();
       mySwitchSend.send(data, 32); //Посылаем год
       mySwitchReceive.enableReceive(0);
//       Serial.print("Send: ");
//       Serial.println(data);
    }   
    len=0;
  }
  
    

} 



